<template>
  <GManageTable
    :card="card"
    :level="level"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value.identification"
    :get-new-item="getNewItem"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item }">
      <v-row dense>
        <GCol cols="12" md="6">
          <GTextField
            v-model="item._attr.refType"
            i18n="dcc.common.attributes.refType"
            attr-ref-type
          />
        </GCol>
        <GCol cols="12" md="6">
          <GAutocomplete
            v-model="item.issuer._text"
            i18n="dcc.common.identificationType.issuer.title"
            :items="issuerItems"
            :item-text="
              (el) => $t(`dcc.common.identificationType.issuer.${el.value}`)
            "
            validate="required"
            wiki-entry="identificationsIssuer"
          />
        </GCol>
        <GCol cols="12">
          <XmlTextField
            v-model="item.value"
            i18n="dcc.common.identificationType.value"
            validate="required notEmptyStringType"
            wiki-entry="identificationsValue"
          />
        </GCol>
        <GCol cols="12">
          <DccLocalizedTextarea
            v-model="item.name"
            i18n="dcc.common.identificationType.name"
            wiki-entry="identificationsName"
          />
        </GCol>
      </v-row>
    </template>

    <template #[`item.issuer`]="{ item }">
      {{ $t(`dcc.common.identificationType.issuer.${item.issuer._text}`) }}
    </template>
    <template #[`item.name`]="{ item }">
      {{ getName(item) }}
    </template>
  </GManageTable>
</template>

<script>
import { IdentificationType } from "@d-ptb/dcc-js";
import { removeFromArray } from "assets/util/general";
import GAutocomplete from "../../App/Form/gAutocomplete";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import DccLocalizedTextarea from "../../App/Form/XML/DccLocalizedTextarea";
import { validatableMixin } from "../../Mixins/validatableMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import GCol from "~/components/App/Common/GCol";
import GTextField from "~/components/App/Form/gTextField";

export default {
  name: "IdentificationList",
  components: {
    GTextField,
    GCol,
    GManageTable,
    DccLocalizedTextarea,
    XmlTextField,
    GAutocomplete,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.common.identificationListType",
    },
    card: {
      type: Boolean,
      default: true,
    },
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "identifications",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.identificationType.issuer.title"),
          value: "issuer",
        },
        {
          text: this.$t("dcc.common.identificationType.value"),
          value: "value._text",
        },
        {
          text: this.$t("dcc.common.identificationType.name"),
          value: "name",
          sortable: false,
        },
      ],
      issuerItems: [
        { value: "manufacturer" },
        { value: "calibrationLaboratory" },
        { value: "customer" },
        { value: "owner" },
        { value: "other" },
      ],
    };
  },
  computed: {
    customRules() {
      return [() => this.value.identification.length > 0];
    },
  },
  watch: {
    "value.identification"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.identification, item);
    },
    getNewItem() {
      return new IdentificationType();
    },
    create(item) {
      this.value.identification.push(new IdentificationType(item));
    },
    edit(item, index) {
      Object.assign(
        this.value.identification[index],
        new IdentificationType(item)
      );
    },
    getName(item) {
      let desc;
      if (item.name && item.name.content) {
        desc = item.name
          ? item.name.getContent(this.$store.state.currentUsedLangISO639)
          : null;
      }
      return desc ? desc._text : "-";
    },
  },
};
</script>
